/**
 * CS 1 23fa
 * Mini Project 8: PokeLife Simulator (Part B)
 * Student name: TODO
 *
 * Represents a PokeLife instance for the PokeLife game.
 * The PokeLife board provides functionality to run iterations
 * of the game simulator.
 * 
 * TODOs (remove these TODOs from the file comment when done):
 * - B.1 Implement the PokeLife(int x, int y) constructor
 *      -> Given initializeBoard
 * - B.2 Implement the getWidth() and getHeight() getter methods
 * - B.3 Implement the getPoke(int x, int y) getter method
 * - B.4 Implement the getWeaknesses() getter method
 * - B.5 Implement the isSurroundedBy(int x, int y, String type, int count) method
 *      -> Given getNeighborTypes
 * - B.6 Implement the updateType(int x, int y, PokePixel px) method
 * - B.7 Implement the getWinningType() method
 *      -> Given getTypeIndex
 */
public class PokeLife {
    // Class constants
    // A 5-element array of types
    private String[] TYPES = {"Fire", "Water", "Grass", 
                              "Electric", "Ground"};
    // A 5-element array of weaknesses, where each String corresponds to the type
    // in types at that index
    private String[] WEAKNESSES = {"Water,Ground", "Grass,Electric", "Fire", 
                                   "Ground", "Water,Grass"};

    // Class fields
    // width and height of a the "PokeLife" game
    private int width;
    private int height;
    // 2D array holding width * height PokePixel instances
    private PokePixel[][] board;
    // if true, will randomly populate board, otherwise
    // will always populate the same pixel types for a given
    // (width, height)
    private boolean isRandom;
    
    /**
     * Initializes a PokeLife board, with a given width and height.
     *
     * @param width The width of the PokeLife board
     * @param height The height of the PokeLife board
     * @param isRandom Whether to randomly-populate the initialized board
     * @throws IllegalArgumentException if either width or height are < 1
     */
    public PokeLife(int width, int height, boolean isRandom) { 
        // TODO: B.1
    }

    /**
     * Getter method for this PokeLife width.
     *
     * @return The width of this PokeLife
     */
    public int getWidth() {
        // TODO: B.2a (replace TODO and return)
        return 0;
    }

    /**
     * Getter method for this PokeLife height. 
     * 
     * @return The height of this PokeLife
     */
    public int getHeight() {
        // TODO: B.2b (replace TODO and return)
        return 0;
    }
   
    /**
     * Gets the PokePixel at the given x and y position on the board.
     *
     * @param x Desired x coordinate.
     * @param y Desired y coordinate. 
     *
     * @return The PokePixel at (x, y)
     * @throws IllegalArgumentException if (x, y) is an invalid position:
     * - both must be >= 0
     * - x must be < width of board, y must be < height of board
     */
    public PokePixel getPoke(int x, int y) {
        // TODO: B.3 (replace TODO and return)
        return null;
    }

    /**
     * Returns the weaknesses for the given type (case-sensitive).
     * 
     * @param type The type to get the weaknesses for.
     * 
     * @return A 1D array containing all of the weaknesses of the given type, 
     * or null if none exists (the given type is unknown).
     */ 
    public String[] getWeaknesses(String type) {
        // TODO: B.4 (replace TODO and return)
        // Don't forget to read the spec carefully!
        return null;
    }

    /**
     * Returns true if at least count of the neighbors of the PokePixel at 
     * position (x, y) of the board are of the given type (where (0, 0) is
     * the top-left coordinate, increasing down/right) 
     *  
     * @param x The x coordinate of the desired PokePixel
     * @param y The y coordinate of the desired PokePixel
     * @param type The type to check the neighbors for
     * @param count Minimum count of neighbors having the passed type
     *
     * @return true if 3+ neighbors match the type, else false
     */
    public boolean isSurroundedBy(int x, int y, String type, int count) {
        String[] neighborTypes = this.getNeighborTypes(x, y);
        // TODO: B.5 (replace TODO and return)
        // Don't forget to read the spec carefully for the String's .equals vs. ==!
        return false;
    }

    /**
     * Gets the weakness of the relevant PokePixel, and checks its neighbors'
     * types. If at least 3 neighbors are of a type the PokePixel is weak to, 
     * its type should be updated. 
     * 
     * Note: This method would best be declared private as a helper
     * method (not used by clients), but for easier testing (testing programs
     * can have access to it) we've declared it public.
     * 
     * @param x The x coordinate to check neighbors of
     * @param y The y coordinate to check neighbors of 
     * @param current The PokePixel at the relevant coordinates
     */
    public void updateType(int x, int y, PokePixel current) {
        String[] weaknesses = null; // replace null with the appropriate method call
        // TODO: B.6 (replace with one for loop and nested if statement
        // to implement with your two helper methods as described)
        // Where tie-breaking is handled depends on your implementation
        // (but ties should be broken with the last match as described in the
        // spec).
    }

    /**
     * (PROVIDED, DO NOT CHANGE)
     * Given a type string, returns its index in the TYPES array.
     * @return index of type in TYPES array (-1 if not found)
     */
    private int getTypeIndex(String type) {
        for (int i = 0; i < TYPES.length; i++) {
            if (TYPES[i].equals(type)) {
                return i;
            }
        }
        return -1;
    }

    /**
     * Returns the PokePixel type that occurs most on the current state of the
     * board, breaking ties by the latest type tying for the max count 
     * in TYPES.
     */
    public String getWinningType() {
        // Tallies for types:
        // {"Fire", "Water", "Grass", "Electric", "Ground"}
        int[] tallies = {0, 0, 0, 0, 0};
        for (int i = 0; i < this.board.length; i++) {
            PokePixel[] row = this.board[i];
            for (int j = 0; j < row.length; j++) {
                // TODO B.7.1: Finish this code to:
                // a. get the PokePixel cell at (i, j)
                // b. get the typeIndex passing in the cell's getType
                // c. Increment the typeIndex index of tallies by 1
                // (remove these comments when done)
            }
        }

        int maxIndex = 0;
        int maxTally = 0;
        // TODO B.7.2: 
        // Write a loop over tallies to find the maxIndex (the index
        // of tallies with the highest value). To handle ties, we'll 
        // enforce that the maxIndex is the latest tie (so use >= not >
        // when comparing each tally value with maxTally)
        // (remove these comments when done)
        return ""; // (remove this line when done)
    }

    // Provided helper methods (do not change in Parts A/B,
    // you may modify in an optional PokeLife2.java submission for Part C)

    /**
     * Initializes the PokePixel board, populating with as a grid (2D array)
     * of PokePixel instances. If the life is initialized with
     * a randomness flagged true, will randomly allocate the board,
     * otherwise the allocation will always be the same for a given
     * x/y.
     * 
     * Implementation tool for solution -- students not required to implement.
     * @param x number of columns for the board
     * @param y number of rows for the board
     * @return populated board of PokePixel elements.
     */
    private PokePixel[][] initializeBoard(int x, int y) {
        PokePixel[][] board = new PokePixel[x][y];
        int currTypeIndex = 0; 
        // counter for testing without randomness;
        // where we assign types in order, cycling through TYPES 
        for (int i = 0; i < x; i++) {
            for (int j = 0; j < y; j++) {
                board[i][j] = new PokePixel();
                if (!this.isRandom) {
                    board[i][j].changeType(TYPES[currTypeIndex]);
                    // fix a formula for assigning the current index
                    // (just cycling by 1 is a boring horizontal-striped result)
                    currTypeIndex = ((currTypeIndex + 1) * i + j) % TYPES.length;
                }
            }
       }
       return board;
    }

    /**
     * Returns an 8-element array of all the neighbors types, starting 
     * north and going counterclockwise. 
     * 
     * @param x The x coordinate of the PokePixel 
     * @param y The y coordinate of the PokePixel
     * @return 8-element array of all neighbor types
     */
    private String[] getNeighborTypes(int x, int y) {
        String[] neighborsCW = new String[8];
        int down = (y + 1) % this.height; 
        // Ternary syntax: cond ? result1 : results2
        // if (cond) { result1 } else { result2 }
        // if (y == 0) { this.height - 1 } else { y - 1 }
        int up = y == 0 ? this.height - 1 : (y - 1);
        int left = x == 0 ? this.width - 1 : (x - 1);
        int right = (x + 1) % this.width;
        neighborsCW[0] = this.board[x][up].getType(); 
        neighborsCW[1] = this.board[left][up].getType(); 
        neighborsCW[2] = this.board[left][y].getType();
        neighborsCW[3] = this.board[left][down].getType();
        neighborsCW[4] = this.board[x][down].getType(); 
        neighborsCW[5] = this.board[right][down].getType(); 
        neighborsCW[6] = this.board[right][y].getType(); 
        neighborsCW[7] = this.board[right][up].getType();
        return neighborsCW;
    }

    /**
     * Runs a cycle of the PokeLife game, where all pixels check their neighbors 
     * for their respective weaknesses. 
     * If the criteria is met, the type of that given pixel changes for the 
     * next cycle. In the case of two groups weaknesses around the pixel, 
     * the one that appears second later in the weaknesses string should win. 
     */
    public void lifeCycle() {
        for (int i = 0; i < this.width; i++) {
            for (int j = 0; j < this.height; j++) {
                PokePixel curr = this.board[i][j]; 
                updateType(i, j, curr);
            }
        }
    }

    /**
     * 2D grid string representation of the current PokeLife game, where each
     * line of the board represents a row of pixels, ending with "\n".
     * 
     * @return A string representation of this PokeLife.
     */
    public String toString() {
        String result = "";
        // # of rows
        for (int i = 0; i < this.height; i++) {
            // # of cols
            for (int j = 0; j < this.width; j++) {
                // append pixel string at this.board[col][row]
                result += this.board[j][i].toString() + " ";
            }
            result += "\n";
        }
        return result;
    }
}
